[PATCH] perf: test: Add support for testing JSON generated by perf data command

From: Anup Sharma
Date: Wed May 17 2023 - 14:09:42 EST


This commit adds support for testing the JSON output generated
by the perf data command's conversion to JSON functionality.
The test script now includes a validation step to ensure that
the resulting JSON file is contain valid data.

As a newcomer to this community, any feedback on the implementation
is highly appreciated.

Signed-off-by: Anup Sharma <anupnewsmail@xxxxxxxxx>
---
.../shell/test_perf_data_converter_json.sh | 64 +++++++++++++++++++
1 file changed, 64 insertions(+)
create mode 100755 tools/perf/tests/shell/test_perf_data_converter_json.sh

diff --git a/tools/perf/tests/shell/test_perf_data_converter_json.sh b/tools/perf/tests/shell/test_perf_data_converter_json.sh
new file mode 100755
index 000000000000..88db96e38925
--- /dev/null
+++ b/tools/perf/tests/shell/test_perf_data_converter_json.sh
@@ -0,0 +1,64 @@
+#!/bin/sh
+# perf data json converter test
+# SPDX-License-Identifier: GPL-2.0
+
+set -e
+
+err=0
+perfdata=$(mktemp /tmp/__perf_test.perf.data.XXXXX)
+result=$(mktemp /tmp/__perf_test.output.json.XXXXX)
+
+cleanup()
+{
+ rm -f ${perfdata}
+ rm -f ${result}
+ trap - exit term int
+}
+
+trap_cleanup()
+{
+ cleanup
+ exit ${err}
+}
+trap trap_cleanup exit term int
+
+check()
+{
+ if [ `id -u` != 0 ]; then
+ echo "[Skip] No root permission"
+ err=2
+ exit
+ fi
+}
+
+test_json()
+{
+ echo "Testing perf data convertion to JSON"
+ perf record -o $perfdata -F 99 -a -g -- sleep 1 > /dev/null 2>&1
+ perf data convert --to-json $result --force -i $perfdata >/dev/null 2>&1
+ echo "Perf Data Converter to JSON [SUCCESS]"
+}
+
+validate_json_format()
+{
+ echo "Testing perf data converted to JSON format"
+ if [ -f "${result}" ]; then
+ if jq '.' "${result}" > /dev/null 2>&1; then
+ echo "The file contains valid JSON format [SUCCESS]"
+ else
+ echo "The file does not contain valid JSON format [FAILED]"
+ err=1
+ fi
+ else
+ echo "File not found [FAILED]"
+ err=2
+ exit
+ fi
+}
+
+check
+
+test_json
+validate_json_format
+
+exit ${err}
--
2.34.1